# look up table for the hexadecimal numerals
hex_numerals = "0123456789ABCDEF"  

def byte2hex(value):
    hex_str = ""

    # to get the low bits, you apply a 'mask'
    # to the high bits using a bitwise AND.
    
    low_nibble = value & 0x0F
    hex_str += hex_numerals[low_nibble]
    
    # to get the high bits, shift the value to the right
    # by four. The low bits will fall off of the byte,
    # and the high bits will now be in the lower bits.
    
    high_nibble = value >> 4
    hex_str = hex_numerals[high_nibble] + hex_str
    
    return hex_str 
    
    
print(byte2hex(0x1))
print(byte2hex(0x1A))
print(byte2hex(0x4b))
print(byte2hex(0xFF))
print(byte2hex(0xf4))
print(byte2hex(0x09))
print(byte2hex(0x90))
print(byte2hex(0xe9))
print(byte2hex(0x9c))

print("{0} == (5 SHL 3) == (5 * 2^3)  == {1}".format(5 << 3, 5 * (2 ** 3)))
print("{0} == (255 SHL 3) == (255 // 2^3) == {1}".format(255 >> 3, 255 // (2 ** 3)))
